/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of BlumBlumShub.xs. Do not edit this file, edit BlumBlumShub.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "BlumBlumShub.xs"

#ifdef  __MINGW32__
#ifndef __USE_MINGW_ANSI_STDIO
#define __USE_MINGW_ANSI_STDIO 1
#endif
#endif

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <gmp.h>

void bbs(mpz_t * outref, mpz_t * p, mpz_t * q, mpz_t * seed, int bits_required) {
     mpz_t n, gcd, one;
     unsigned long i, k;

     if(mpz_fdiv_ui(*p, 4) != 3) croak ("First prime is unsuitable for Blum-Blum-Shub prbg (must be congruent to 3, mod 4)");
     if(mpz_fdiv_ui(*q, 4) != 3) croak ("Second prime is unsuitable for Blum-Blum-Shub prbg (must be congruent to 3, mod 4)");
     mpz_init(n);

     mpz_mul(n, *p, *q);

     if(mpz_cmp_ui(*seed, 0) < 0)croak("Negative seed supplied to bbs function");
     if(mpz_cmp(*seed, n) >= 0)croak("Seed supplied to bbs function is too big");

     mpz_init(gcd);

     mpz_gcd(gcd, *seed, n);
     if(mpz_cmp_ui(gcd, 1)) croak("gcd(seed, p * q) != 1");

     mpz_powm_ui(*seed, *seed, 2, n);

     mpz_init_set_ui(*outref, 0);
     mpz_init_set_ui(one, 1);

     for(i = 0; i < bits_required; ++i) {
       mpz_powm_ui(*seed, *seed, 2, n);
    /* Next 2 lines (from Dana Jacobsen) provide a significant performance improvement over the original */
       if(mpz_tstbit(*seed, 0))
         mpz_setbit(*outref, i);
     }

     mpz_clear(n);
     mpz_clear(gcd);
     mpz_clear(one);

}

void bbs_seedgen(mpz_t * seed, mpz_t * p, mpz_t * q) {
     mpz_t n, gcd;
     gmp_randstate_t state;

     mpz_init(n);

     mpz_mul(n, *p, *q);

     mpz_init(gcd);

     if(mpz_cmp_ui(*seed, 0) < 0)croak("Negative seed supplied to bbs_seedgen");
     gmp_randinit_default(state);
     gmp_randseed(state, *seed);
     mpz_urandomm(*seed, state, n);
     gmp_randclear(state);

     while(1) {
       mpz_gcd(gcd, *seed, n);
       if(!mpz_cmp_ui(gcd, 1)) break;
       mpz_sub_ui(*seed, *seed, 1);
     }

     mpz_clear(n);
     mpz_clear(gcd);
}

int monobit(mpz_t * bitstream) {
    unsigned long len, i, count = 0;

    len = mpz_sizeinbase(*bitstream, 2);

    if(len > 20000) croak("Wrong size random sequence for monobit test");
    if(len < 19967) {
       warn("More than 33 leading zeroes in monobit test\n");
       return 0;
       }

    count = mpz_popcount(*bitstream);

    if(count > 9654 && count < 10346) return 1;
    return 0;

}

int longrun(mpz_t * bitstream) {
    unsigned long i, el, init = 0, count = 0, len, t;

    len = mpz_sizeinbase(*bitstream, 2);

    if(len > 20000) croak("Wrong size random sequence for Rlong_run test");
    if(len < 19967) {
       warn("More than 33 leading zeroes in long_run test\n");
       return 0;
       }

    el = mpz_tstbit(*bitstream, 0);

    for(i = 0; i < len; ++i) {
        t = mpz_tstbit(*bitstream, i);
        if(t == el) ++count;
        else {
           el = t;
           if(count > init) init = count;
           count = 1;
           }
        }

    if(init < 34 && count < 34) return 1;
    else warn("init: %d count: %d", init, count);
    return 0;

}

int runs(mpz_t * bitstream) {
    int b[6] = {0,0,0,0,0,0}, g[6] = {0,0,0,0,0,0},
    len, count = 1, i, t, diff;

    len = mpz_sizeinbase(*bitstream, 2);
    diff = 20000 - len;

    if(len > 20000) croak("Wrong size random sequence for monobit test");
    if(len < 19967) {
       warn("More than 33 leading zeroes in runs test\n");
       return 0;
       }

    --len;

    for(i = 0; i < len; ++i) {
      t = mpz_tstbit(*bitstream, i);
      if(t == mpz_tstbit(*bitstream, i + 1)) ++ count;
      else {
        if(t) {
          if(count >= 6) ++b[5];
          else ++b[count - 1];
        }
        else {
          if(count >= 6) ++g[5];
          else ++g[count - 1];
        }
        count = 1;
      }
    }

    if(count >= 6) {
      if(mpz_tstbit(*bitstream, len)) {
        ++b[5];
        if(diff >= 6) {
          ++g[5];
        }
        else {
          if(diff) ++g[diff - 1];
        }
      }
      else ++g[5];
      }
    else {
      if(mpz_tstbit(*bitstream, len)) {
        ++b[count - 1];
        if(diff >= 6) {
          ++g[5];
        }
        else {
          if(diff) ++ g[diff - 1];
        }
      }
      else {
        count += diff;
        count >= 6 ? ++g[5] : ++g[count - 1];
      }
    }


    if (
            b[0] <= 2267 || g[0] <= 2267 ||
            b[0] >= 2733 || g[0] >= 2733 ||
            b[1] <= 1079 || g[1] <= 1079 ||
            b[1] >= 1421 || g[1] >= 1421 ||
            b[2] <= 502  || g[2] <= 502  ||
            b[2] >= 748  || g[2] >= 748  ||
            b[3] <= 223  || g[3] <= 223  ||
            b[3] >= 402  || g[3] >= 402  ||
            b[4] <= 90   || g[4] <= 90   ||
            b[4] >= 223  || g[4] >= 223  ||
            b[5] <= 90   || g[5] <= 90   ||
            b[5] >= 223  || g[5] >= 223
           ) return 0;

    return 1;

}

int poker (mpz_t * bitstream) {
    int counts[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
       len, i, st, last, short_ = 0;
    double n = 0;
    mpz_t temp;

    len = mpz_sizeinbase(*bitstream, 2);

    if(len > 20000) croak("Wrong size random sequence for poker test");
    if(len < 19967) {
       warn("More than 33 leading zeroes in poker test\n");
       return 0;
       }

/* pad with trailing zeroes (if necessary) to achieve length of 20000 bits. */
    if(20000 - len) {
      short_ = 1;
      mpz_init_set_ui(temp, 1);
      mpz_mul_2exp(temp, temp, 19999);
      mpz_add(*bitstream, *bitstream, temp);
    }
    if(mpz_sizeinbase(*bitstream, 2) != 20000) croak("Bit sequence has length of %d bits in poker function", mpz_sizeinbase(*bitstream, 2));

    for(i = 0; i < 19996; i += 4) {
        st = mpz_tstbit(*bitstream, i) +
             (mpz_tstbit(*bitstream, i + 1) * 2) +
             (mpz_tstbit(*bitstream, i + 2) * 4) +
             (mpz_tstbit(*bitstream, i + 3) * 8);
        ++counts[st];
        }

    last = short_ ? 0 : 1;

    st = mpz_tstbit(*bitstream, 19996) +
         (mpz_tstbit(*bitstream, 19997) * 2) +
         (mpz_tstbit(*bitstream, 19998) * 4) +
         (last * 8);
    ++counts[st];

/* restore *bitstream to its original value && free temp (iff necessary) */
    if(short_) {
      mpz_sub(*bitstream, *bitstream, temp);
      mpz_clear(temp);
    }

    for(i = 0; i < 16; ++i) n += counts[i] * counts[i];

    n /= 5000;
    n *= 16;
    n -= 5000;

    if(n > 1.03 && n < 57.4) return 1;

    return 0;
}

void autocorrelation(pTHX_ mpz_t * bitstream, int offset) {
     dXSARGS;
     int i, index, last, count = 0, short_ = 0;
     mpz_t temp;
     double x, diff;
     int len = mpz_sizeinbase(*bitstream, 2);

     if(len > 20000) croak("Wrong size random sequence for autocorrelation test");
     if(len < 19967) {
        warn("More than 33 leading zeroes in autocorrelation test\n");
        ST(0) = sv_2mortal(newSViv(0));
        ST(1) = sv_2mortal(newSVnv(0.0));
        XSRETURN(2);
        }

/* make sure *bitstream has a length of 20000 bits. */
     if(20000 - len) {
       short_ = 1;
       mpz_init_set_ui(temp, 1);
       mpz_mul_2exp(temp, temp, 19999);
       mpz_add(*bitstream, *bitstream, temp);
     }
     if(mpz_sizeinbase(*bitstream, 2) != 20000) croak("Bit sequence has length of %d bits in autocorrelation function", mpz_sizeinbase(*bitstream, 2));

     index = 19999 - offset;
     for(i = 0; i < index - 1; ++i) {
       if(mpz_tstbit(*bitstream, i) ^ mpz_tstbit(*bitstream, i + offset)) count += 1;
     }

     last = short_ ? 0 : 1;

     if(mpz_tstbit(*bitstream, index - 1) ^ last) count += 1;

/* restore *bitstream to its original value && free temp (iff necessary) */
     if(short_) {
       mpz_sub(*bitstream, *bitstream, temp);
       mpz_clear(temp);
     }

   ST(0) = sv_2mortal(newSViv(count));

   diff = 20000.0 - (double)offset;
   x = (2 * ((double)count - (diff / 2))) / (sqrt(diff));

   ST(1) = sv_2mortal(newSVnv(x));
   XSRETURN(2);
}

int autocorrelation_20000(pTHX_ mpz_t * bitstream, int offset) {

    int i, last, count = 0, short_ = 0;
    mpz_t temp;
    double x, diff;
    int len = mpz_sizeinbase(*bitstream, 2);

    if(len > 20000 + offset) croak("Wrong size random sequence for autocorrelation_20000 test");
    if(len < 19967 + offset) {
      warn("More than 33 leading zeroes in autocorrelation_20000 test\n");
      return 0;
    }

/* make sure *bitstream has a length of 20000 + offset bits. */
    if(20000 + offset - len) {
      short_ = 1;
      mpz_init_set_ui(temp, 1);
      mpz_mul_2exp(temp, temp, 19999 + offset);
      mpz_add(*bitstream, *bitstream, temp);
    }
   if(mpz_sizeinbase(*bitstream, 2) != 20000 + offset) croak("Bit sequence has length of %d bits in autocorrelation_20000 function; should have size of %d bits", mpz_sizeinbase(*bitstream, 2), 20000 + offset);

    for(i = 0; i < 19999; ++i) {
      if(mpz_tstbit(*bitstream, i) ^ mpz_tstbit(*bitstream, i + offset)) count += 1;
    }

    last = short_ ? 0 : 1;

    if(mpz_tstbit(*bitstream, 19999) ^ last) count += 1;

/* restore *bitstream to its original value && free temp (iff necessary) */
    if(short_) {
      mpz_sub(*bitstream, *bitstream, temp);
      mpz_clear(temp);
    }
    if(count > 9654 && count < 10346) return 1;
    return 0;
}

SV * _get_xs_version(pTHX) {
     return newSVpv(XS_VERSION, 0);
}


#line 362 "BlumBlumShub.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 506 "BlumBlumShub.c"

XS_EUPXS(XS_Math__Random__BlumBlumShub_bbs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_bbs)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "outref, p, q, seed, bits_required");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            outref = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            p = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	mpz_t *            seed = INT2PTR(mpz_t *, SvIVX(SvRV(ST(3))))
;
	int	bits_required = (int)SvIV(ST(4))
;
#line 365 "BlumBlumShub.xs"
        I32* temp;
#line 529 "BlumBlumShub.c"
#line 367 "BlumBlumShub.xs"
        temp = PL_markstack_ptr++;
        bbs(outref, p, q, seed, bits_required);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 540 "BlumBlumShub.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__BlumBlumShub_bbs_seedgen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_bbs_seedgen)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "seed, p, q");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            seed = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            p = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
#line 383 "BlumBlumShub.xs"
        I32* temp;
#line 564 "BlumBlumShub.c"
#line 385 "BlumBlumShub.xs"
        temp = PL_markstack_ptr++;
        bbs_seedgen(seed, p, q);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 575 "BlumBlumShub.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__BlumBlumShub_monobit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_monobit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bitstream");
    {
	mpz_t *            bitstream = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = monobit(bitstream);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__BlumBlumShub_longrun); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_longrun)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bitstream");
    {
	mpz_t *            bitstream = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = longrun(bitstream);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__BlumBlumShub_runs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_runs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bitstream");
    {
	mpz_t *            bitstream = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = runs(bitstream);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__BlumBlumShub_poker); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_poker)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "bitstream");
    {
	mpz_t *            bitstream = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = poker(bitstream);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__BlumBlumShub_autocorrelation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_autocorrelation)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bitstream, offset");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            bitstream = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	int	offset = (int)SvIV(ST(1))
;
#line 416 "BlumBlumShub.xs"
        I32* temp;
#line 673 "BlumBlumShub.c"
#line 418 "BlumBlumShub.xs"
        temp = PL_markstack_ptr++;
        autocorrelation(aTHX_ bitstream, offset);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 684 "BlumBlumShub.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Random__BlumBlumShub_autocorrelation_20000); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub_autocorrelation_20000)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bitstream, offset");
    {
	mpz_t *            bitstream = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	int	offset = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 433 "BlumBlumShub.xs"
  RETVAL = autocorrelation_20000 (aTHX_ bitstream, offset);
#line 706 "BlumBlumShub.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Random__BlumBlumShub__get_xs_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Random__BlumBlumShub__get_xs_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 439 "BlumBlumShub.xs"
  RETVAL = _get_xs_version (aTHX);
#line 723 "BlumBlumShub.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Math__Random__BlumBlumShub); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Random__BlumBlumShub)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::Random::BlumBlumShub::bbs", XS_Math__Random__BlumBlumShub_bbs);
        newXS_deffile("Math::Random::BlumBlumShub::bbs_seedgen", XS_Math__Random__BlumBlumShub_bbs_seedgen);
        newXS_deffile("Math::Random::BlumBlumShub::monobit", XS_Math__Random__BlumBlumShub_monobit);
        newXS_deffile("Math::Random::BlumBlumShub::longrun", XS_Math__Random__BlumBlumShub_longrun);
        newXS_deffile("Math::Random::BlumBlumShub::runs", XS_Math__Random__BlumBlumShub_runs);
        newXS_deffile("Math::Random::BlumBlumShub::poker", XS_Math__Random__BlumBlumShub_poker);
        newXS_deffile("Math::Random::BlumBlumShub::autocorrelation", XS_Math__Random__BlumBlumShub_autocorrelation);
        newXS_deffile("Math::Random::BlumBlumShub::autocorrelation_20000", XS_Math__Random__BlumBlumShub_autocorrelation_20000);
        newXS_deffile("Math::Random::BlumBlumShub::_get_xs_version", XS_Math__Random__BlumBlumShub__get_xs_version);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

